<!DOCTYPE html>
<html lang="en">

<head>
  <title>37.60</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng đăng ký</h2>
    </div>
    <div class="text-left my-4">
      <button id="btn-add-user" class="btn btn-success">Thêm user</button>
    </div>
    <table id="user-table" class="table table-bordered table-striped table-hover text-center">
      <thead>
        <tr>
          <th>ID</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody id="tbody-user">
        
      </tbody>
    </table>
  </div>
  <!-- insert modal section -->
  <div id="add-user-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Thêm User</h5>
          <button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
          <div class="row form-group">
            <div class="col-sm-4">
              <label for="firstname">Firstname</label>
            </div>
            <div class="col-sm-8">
              <input class="form-control" type="text" name="firstname" id="firstname">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label for="lastname">Lastname</label>
            </div>
            <div class="col-sm-8">
              <input class="form-control" type="text" name="lastname" id="lastname">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label for="subject">Subject</label>
            </div>
            <div class="col-sm-8">
              <input class="form-control" type="text" name="subject" id="subject">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label for="country">Country</label>
            </div>
            <div class="col-sm-8">
              <select class="form-control" name="country" id="country">
                <option value="VN">Việt Nam</option>
                <option value="USA">USA</option>
                <option value="AUS">Australia</option>
                <option value="CAN">Canada</option>
              </select>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <div class="col-sm-12 text-center">
            <button id="btn-modal-insert-user" class="btn btn-success">Insert user</button>
            <button id="btn-modal-cancel" class="btn btn-danger" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- edit modal section -->
  <div id="edit-user-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Chi tiết User</h5>
          <button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
          <div class="row form-group">
            <div class="col-sm-4">
              <label for="firstname">Firstname</label>
            </div>
            <div class="col-sm-8">
              <input class="form-control" type="text" name="firstname-edit" id="firstname-edit">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label for="lastname">Lastname</label>
            </div>
            <div class="col-sm-8">
              <input class="form-control" type="text" name="lastname-edit" id="lastname-edit">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label for="subject">Subject</label>
            </div>
            <div class="col-sm-8">
              <input class="form-control" type="text" name="subject-edit" id="subject-edit">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label for="country">Country</label>
            </div>
            <div class="col-sm-8">
              <select class="form-control" name="country" id="country-edit">
                <option value="VN">Việt Nam</option>
                <option value="USA">USA</option>
                <option value="AUS">Australia</option>
                <option value="CAN">Canada</option>
              </select>
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label for="customerType">Customer Type</label>
            </div>
            <div class="col-sm-8">
              <select class="form-control" name="customerType" id="customerType">
                <option value="Standard">Standard</option>
                <option value="Gold">Gold</option>
                <option value="Premium">Premium</option>
              </select>
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label for="registerStatus">Register Status</label>
            </div>
            <div class="col-sm-8">
              <select class="form-control" name="registerStatus" id="registerStatus">
                <option value="Accepted">Accepted</option>
                <option value="Denied">Denied</option>
                <option value="Standard">Standard</option>
              </select>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <div class="col-sm-12 text-center">
            <button id="btn-modal-update-user" class="btn btn-success">Update user</button>
            <button id="btn-modal-cancel-update" class="btn btn-danger" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- delete user modal -->
  <div id="delete-user-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Confirm xoá user</h5>
          <button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
          <label for="delete">Bạn có chắc chắn muốn xóa user này không?</label>
        </div>
        <div class="modal-footer">
          <div class="col-sm-12 text-center">
            <button id="btn-modal-delete-user" class="btn btn-danger">Xác nhận</button>
            <button id="btn-modal-cancel-delete" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
  </div>

</body>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gBASE_URL = "http://42.115.221.44:8080/crud-api/users/";
  const gUSER_ID_COL = 0;
  const gFIRST_NAME_COL = 1;
  const gLAST_NAME_COL = 2;
  const gCOUNTRY_COL = 3;
  const gSUBJECT_COL = 4;
  const gCUSTOMER_TYPE_COL = 5;
  const gREGISTER_STATUS_COL = 6;
  const gACTION_COL = 7;
  var gNameCol = ['id', 'firstname', 'lastname', 'country', 'subject', 'customerType', 'registerStatus', 'action'];
  var gUserId = 0;

  $(document).ready(function(){
    onPageLoading();
    
    //Edit button
    $("#user-table").on('click', '.btn-edit', function(){
      onBtnActionClick(this, 'edit');
    });

    //Delete button
    $("#user-table").on('click', '.btn-delete', function(){
      onBtnActionClick(this, 'delete');
    });

    //Add new user button
    $("#btn-add-user").on('click', function(){
      onBtnAddNewUserClick();
    });
    
    // Add new user modal
    $("#btn-modal-insert-user").on('click', function(){
      onBtnInsertUserModalClick();
    });

    // Edit user modal
    $("#btn-modal-update-user").on('click', function(){
      onBtnUpdateUserModalClick();
    });

    // Delete user modal
    $("#btn-modal-delete-user").on('click', function(){
      onBtnDeleteUserModalClick();
    });
  });

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  function onPageLoading() {
    "use-strict"
    callApiGetAllUsers();
  }
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function callApiGetAllUsers() {
    "use-strict"
    $.ajax({
      url: gBASE_URL,
      type: "GET",
      dataType: 'json',
      async: false,
      success: renderDaTaToTable,
      error: function(e){
        console.assert(e.responseText);
      }
    });
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function renderDaTaToTable(paramResponse) {
    "use-strict"
    console.log("ghi được Response ra console");
    console.log(paramResponse);

    var vTable = $("#user-table").DataTable({
      columns:[
          {data: gNameCol[gUSER_ID_COL]},
          {data: gNameCol[gFIRST_NAME_COL]},
          {data: gNameCol[gLAST_NAME_COL]},
          {data: gNameCol[gCOUNTRY_COL]},
          {data: gNameCol[gSUBJECT_COL]},
          {data: gNameCol[gCUSTOMER_TYPE_COL]},
          {data: gNameCol[gREGISTER_STATUS_COL]},
          {data: gNameCol[gACTION_COL]},
        ],
        columnDefs:[
          {
            targets: gACTION_COL,
            className: "text-center",
            defaultContent: `
            <div class="btn-group" role="group">
              <button class="btn btn-primary rounded btn-edit mr-2">Sửa</button>
              <button class="btn btn-danger rounded btn-delete">Xoá</button>
            </div>
            `
          }
        ],
        bDestroy: true // fix error cannot reinitialise data table
    });
    addDataToTable(paramResponse);
  }

  function addDataToTable(paramResponse) {
    "use-strict"
    var vTable = $("#user-table").DataTable();
    vTable.clear();
    vTable.rows.add(paramResponse);
    vTable.draw();
  }

  function onBtnActionClick(paramBtn, paramAction) {
    "use-strict"
    console.log("Nút " + paramAction + " được nhấn");
    var vThisRow = $(paramBtn).closest('tr');
    var vTable = $("#user-table").DataTable();
    var vThisRowData = vTable.row(vThisRow).data();
    console.log(vThisRowData);
    if(paramAction == 'edit') {
      //Get current user data and put to edit modal
      $("#firstname-edit").val(vThisRowData.firstname);
      $("#lastname-edit").val(vThisRowData.lastname);
      $("#subject-edit").val(vThisRowData.subject);
      $("#country-edit").val(vThisRowData.country);
      $("#customerType").val(vThisRowData.customerType);
      $("#registerStatus").val(vThisRowData.registerStatus);
      gUserId = vThisRowData.id; // Gán userId cho biến để sử dụng cho hàm update
      //Hiện edit modal lên
      $("#edit-user-modal").modal('show');
    }
    if(paramAction == 'delete') {
      gUserId = vThisRowData.id;
      $("#delete-user-modal").modal('show');
    }
  }

  function onBtnAddNewUserClick() {
    "use-strict"
    $("#add-user-modal").modal('show');
  }

  function onBtnInsertUserModalClick() {
    "use-strict"
    // Khai báo đối tượng chứa dữ liệu
    var vUserObj = {
      firstname: "",
      lastname: "",
      subject: "",
      country: ""
    }
    console.log("Nút Insert user dc nhấn");
    //B1 thu thập dữ liệu
    getDataFromModal(vUserObj);
    //B2 xác nhận dữ liệu
    var vCheck = validateDataInPut(vUserObj);
    //B3 insert user
    if(vCheck) {
      callApiCreateNewUser(vUserObj);
    }
    //B4 xử lý front end
  }

  function getDataFromModal(paramUserObj) {
    "use-strict"
    paramUserObj.firstname = $("#firstname").val().trim();
    paramUserObj.lastname = $("#lastname").val().trim();
    paramUserObj.subject = $("#subject").val().trim();
    paramUserObj.country = $("#country").val();
  }

  function validateDataInPut(paramUserObj) {
    "use-strict"
    var vResult = true;
    if(paramUserObj.firstname == "") {
      alert("Chưa nhập firstname!");
      vResult = false;
    }
    if(paramUserObj.lastname == "") {
      alert("Chưa nhập lastname!");
      vResult = false;
    }
    if(paramUserObj.subject == "") {
      alert("Chưa nhập subject!");
      vResult = false;
    }
    if(paramUserObj.country == "") {
      alert("Chưa chọn country!");
      vResult = false;
    }
    return vResult;
  }

  function callApiCreateNewUser(paramUserObj) {
    "use-strict"
    $.ajax({
      url: gBASE_URL,
      type: "POST",
      dataType: 'json',
      data: JSON.stringify(paramUserObj),
      contentType: "application/json;charset=UTF-8",
      async: false,
      success: insertUserSuccess,
      error: function(e){
        console.assert(e.responseText);
      }
    });
  }

  function insertUserSuccess() {
    "use-strict"
    alert("Thêm user thành công");
    // xóa trắng dữ liệu trên modal
    $("#firstname").val('');
    $("#lastname").val('');
    $("#subject").val('');

    // tắt Modal
    $("#add-user-modal").modal('hide');

    //load lại bảng danh sách users
    callApiGetAllUsers();
  }

  function onBtnUpdateUserModalClick() {
    console.log("Nút update user dc nhấn!");
    "use-strict"
    // Khai báo đối tượng chứa dữ liệu
    var vUserObj = {
      firstname: "",
      lastname: "",
      subject: "",
      country: "",
      customerType: "",
      registerStatus: ""
    }

    //B1: Lấy dữ liệu
    vUserObj.firstname = $("#firstname-edit").val();
    vUserObj.lastname = $("#lastname-edit").val();
    vUserObj.subject = $("#subject-edit").val();
    vUserObj.country = $("#country-edit").val();
    vUserObj.customerType = $("#customerType").val();
    vUserObj.registerStatus = $("#registerStatus").val();

    //B2: Kiểm tra dữ liệu
    var vCheck = validateDataInPut(vUserObj); // Sử dụng chung hàm validate dành cho crate, update 

    //B3: Update user
    if(vCheck) {
      callApiUpdateUser(vUserObj);
    }
  }

  function callApiUpdateUser(paramUserObj) {
    "use-strict"
    $.ajax({
      url: gBASE_URL + gUserId,
      type: "PUT",
      dataType: 'json',
      data: JSON.stringify(paramUserObj),
      contentType: "application/json;charset=UTF-8",
      async: false,
      success: updateUserSuccess,
      error: function(e){
        console.assert(e.responseText);
      }
    });
  }

  function updateUserSuccess(paramUserObj) {
    "use-strict"
    alert("Update user: " + paramUserObj.id + " thành công");
    
    // xóa trắng dữ liệu trên modal
    $("#firstname-edit").val();
    $("#lastname-edit").val();
    $("#subject-edit").val();

    // tắt Modal
    $("#edit-user-modal").modal('hide');

    //load lại bảng danh sách users
    callApiGetAllUsers();
  }

  function onBtnDeleteUserModalClick() {
    "use-strict"
    $.ajax({
      url: gBASE_URL + gUserId,
      type: "DELETE",
      contentType: "application/json;charset=UTF-8",
      async: false,
      success: deleteUserSuccess,
      error: function(e){
        console.assert(e.responseText);
      }
    });
  }

  function deleteUserSuccess() {
    "use-strict"
    alert("Delete user: " + gUserId + " thành công");

    // tắt Modal
    $("#delete-user-modal").modal('hide');

    //load lại bảng danh sách users
    callApiGetAllUsers();
  }
</script>
</html>
